## pcl 1.10.0+dfsg

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

if(POLICY CMP0074)
  # 1. Remove with 3.12.4.
  # 2. Remove search paths with *_ROOT since they will be automatically checked
  cmake_policy(SET CMP0074 NEW)
endif()

# Set target C++ standard and required compiler features
set(CMAKE_CXX_STANDARD 14 CACHE STRING "The target C++ standard. PCL requires C++14 or higher.")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
if(CMAKE_VERSION VERSION_LESS 3.8)
  # CMake did not have cxx_std_14 compile feature prior to 3.8
  # We use cxx_attribute_deprecated as a proxy because this feature is a part of c++14 standard
  set(PCL_CXX_COMPILE_FEATURES cxx_attribute_deprecated)
else()
  set(PCL_CXX_COMPILE_FEATURES cxx_std_14)
endif()

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif()

project(PCL VERSION 1.10.0)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Include pkgconfig
include(FindPkgConfig)

# ---[ Release/Debug specific flags
if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  add_definitions("-DBOOST_DISABLE_ASSERTS -DEIGEN_NO_DEBUG")
endif()
if(WIN32 AND NOT MINGW)
  set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "Add postfix to target for Debug build.")
  set(CMAKE_RELEASE_POSTFIX "" CACHE STRING "Add postfix to target for Release build.")
  set(CMAKE_RELWITHDEBINFO_POSTFIX "rd" CACHE STRING "Add postfix to target for RelWithDebInfo build.")
  set(CMAKE_MINSIZEREL_POSTFIX "s" CACHE STRING "Add postfix to target for MinSizeRel build")
endif()

# ---[ special maintainer mode
set(CMAKE_CXX_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C++ compiler during maintainer builds."
    FORCE)
set(CMAKE_C_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C compiler during maintainer builds."
    FORCE)
set(CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used for linking binaries during maintainer builds."
    FORCE)
set(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used by the shared libraries linker during maintainer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_MAINTAINER
    CMAKE_C_FLAGS_MAINTAINER
    CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    CMAKE_SHARED_LINKER_FLAGS_MAINTAINER)
# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Maintainer."
    FORCE)

# Compiler identification
# Define a variable CMAKE_COMPILER_IS_X where X is the compiler short name.
# Note: CMake automatically defines one for GNUCXX, nothing to do in this case.
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif(__COMPILER_PATHSCALE)
  set(CMAKE_COMPILER_IS_PATHSCALE 1)
elseif(MSVC)
  set(CMAKE_COMPILER_IS_MSVC 1)
endif()

# Create a variable with expected default CXX flags
# This will be used further down the road to check if the user explicitly provided CXX flags
if(CMAKE_COMPILER_IS_MSVC)
  set(CMAKE_CXX_FLAGS_DEFAULT "/DWIN32 /D_WINDOWS /W3 /GR /EHsc")
else()
  set(CMAKE_CXX_FLAGS_DEFAULT "")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_options.cmake")
include("${PCL_SOURCE_DIR}/cmake/clang-format.cmake")

if(${PCL_ENABLE_CCACHE})
  include (UseCompilerCache)
  UseCompilerCache(ccache REQUIRED)
endif()

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif()

# check for SSE flags
include("${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake")
if(PCL_ENABLE_SSE AND "${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
  PCL_CHECK_FOR_SSE()
endif()

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi=11")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS_STR}")
    if(PCL_WARNINGS_ARE_ERRORS)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    endif()
  endif()

  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "" AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed")
  endif()

  if(WIN32)
    if(PCL_SHARED_LIBS)
      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if(MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--allow-multiple-definition")
      endif()
    else()
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif()
  endif()
endif()

if(CMAKE_COMPILER_IS_MSVC)
  add_definitions("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -DPCL_ONLY_CORE_POINT_TYPES /bigobj ${SSE_DEFINITIONS}")

  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS_STR}")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
      set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
      set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG /OPT:REF")
      set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    endif()
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if(PCL_WARNINGS_ARE_ERRORS)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX")
    endif()

    include(ProcessorCount)
    ProcessorCount(CPUCores)
    set(MSVC_MP ${CPUCores} CACHE STRING "Number of simultaneously running compilers (0 = automatic detection by MSVC). See documentation of /MP flag.")
    if (CMAKE_VERSION VERSION_LESS 3.11.0)
      # Usage of COMPILE_LANGUAGE generator expression for MSVC in add_compile_options requires at least CMake 3.11, see https://gitlab.kitware.com/cmake/cmake/issues/17435	  
      if(MSVC_MP EQUAL 0)
        # MSVC_MP is 0 in case the information cannot be determined by ProcessorCount => fallback
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
      elseif(MSVC_MP GREATER 1)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP${MSVC_MP}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP${MSVC_MP}")
      endif()      
    else()      
      if(MSVC_MP EQUAL 0)
        # MSVC_MP is 0 in case the information cannot be determined by ProcessorCount => fallback
        # Generator expression is necessary to limit /MP flag to C/CXX, so flag will be not set to e.g. CUDA (see https://gitlab.kitware.com/cmake/cmake/issues/17535)
        add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:/MP>)
      elseif(MSVC_MP GREATER 1)
        add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:/MP${MSVC_MP}>)
      endif()
    endif()
  endif()

  if(CMAKE_GENERATOR STREQUAL "Ninja")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /FS")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /FS")
  endif()
endif()

if(CMAKE_COMPILER_IS_PATHSCALE)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    set(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -mp")
  endif()
  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "")
    set(CMAKE_SHARED_LINKER_FLAGS "-mp")
  endif()
endif()

if(CMAKE_COMPILER_IS_CLANG)
  if("${CMAKE_C_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    set(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    set(CMAKE_CXX_FLAGS "-ftemplate-depth=1024 -Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS_STR}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
    if(APPLE AND WITH_CUDA AND CUDA_FOUND)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
    endif()
  endif()
  set(CLANG_LIBRARIES "stdc++")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR "${PCL_SOURCE_DIR}/resources")
  set(PCL_POINTCLOUDS_DIR "${PCL_RESOURCES_DIR}/pointclouds")
endif()

set(PCL_OUTPUT_LIB_DIR "${PCL_BINARY_DIR}/${LIB_INSTALL_DIR}")
set(PCL_OUTPUT_BIN_DIR "${PCL_BINARY_DIR}/${BIN_INSTALL_DIR}")
make_directory("${PCL_OUTPUT_LIB_DIR}")
make_directory("${PCL_OUTPUT_BIN_DIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
if(WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach()
else()
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif()

# Check if the current generator is an IDE.
check_if_ide(CMAKE_GENERATOR_IS_IDE)

# Add an "uninstall" target
if(CMAKE_GENERATOR_IS_IDE)
  set(UNINSTALL_TARGET_NAME UNINSTALL)
else()
  set(UNINSTALL_TARGET_NAME uninstall)
endif()
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(${UNINSTALL_TARGET_NAME} "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
set(CMAKE_SKIP_BUILD_RPATH  FALSE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
if("${is_system_dir}" STREQUAL "-1")
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
endif()

### ---[ Find universal dependencies
find_package(OpenMP)
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  message(STATUS "Found OpenMP")
  if(MSVC)
    if(MSVC_VERSION EQUAL 1900)
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION MATCHES "^191[0-9]$")
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION MATCHES "^192[0-9]$")
      set(OPENMP_DLL VCOMP140)
    endif()
    if(OPENMP_DLL)
      set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DELAYLOAD:${OPENMP_DLL}D.dll")
      set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DELAYLOAD:${OPENMP_DLL}.dll")
    else()

=== 2d/CMakeLists.txt ===
set(SUBSYS_NAME 2d)
set(SUBSYS_DESC "Point cloud 2d")
set(SUBSYS_DEPS common filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS vtk)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/convolution_2d.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/convolution.h"
  "include/pcl/${SUBSYS_NAME}/kernel.h"
  "include/pcl/${SUBSYS_NAME}/edge.h"
  "include/pcl/${SUBSYS_NAME}/morphology.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/kernel.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/edge.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/morphology.hpp"
)

if(${VTK_FOUND})
  set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
  include("${VTK_USE_FILE}")
  set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging)
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

set(LIB_NAME "pcl_${SUBSYS_NAME}")
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} HEADER_ONLY)

#Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== apps/CMakeLists.txt ===
set(SUBSYS_NAME apps)
set(SUBSYS_DESC "Application examples/samples that show how PCL works")
set(SUBSYS_DEPS common geometry io filters sample_consensus segmentation visualization kdtree features surface octree registration keypoints tracking search recognition ml stereo 2d)

set(DEFAULT FALSE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni vtk)

if(NOT build)
  return()
endif()

# to be filled with all targets the apps subsystem
set(PCL_APPS_ALL_TARGETS)

include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/include")

PCL_ADD_EXECUTABLE(pcl_test_search_speed COMPONENT ${SUBSYS_NAME} SOURCES src/test_search.cpp)
target_link_libraries(pcl_test_search_speed pcl_common pcl_io pcl_search pcl_kdtree pcl_visualization)

PCL_ADD_EXECUTABLE(pcl_nn_classification_example COMPONENT ${SUBSYS_NAME} SOURCES src/nn_classification_example.cpp)
target_link_libraries(pcl_nn_classification_example pcl_common pcl_io pcl_features pcl_kdtree)

PCL_ADD_EXECUTABLE(pcl_pyramid_surface_matching COMPONENT ${SUBSYS_NAME} SOURCES src/pyramid_surface_matching.cpp)
target_link_libraries(pcl_pyramid_surface_matching pcl_common pcl_io pcl_features pcl_registration pcl_filters)

PCL_ADD_EXECUTABLE(pcl_statistical_multiscale_interest_region_extraction_example COMPONENT ${SUBSYS_NAME} SOURCES src/statistical_multiscale_interest_region_extraction_example.cpp)
target_link_libraries(pcl_statistical_multiscale_interest_region_extraction_example pcl_common pcl_io pcl_features pcl_filters)

if(LIBUSB_1_FOUND)
  PCL_ADD_EXECUTABLE(pcl_dinast_grabber COMPONENT ${SUBSYS_NAME} SOURCES src/dinast_grabber_example.cpp)
  target_link_libraries(pcl_dinast_grabber pcl_common pcl_visualization pcl_io)
endif()

if(VTK_FOUND)
  include("${VTK_USE_FILE}")

  set(incs "include/pcl/${SUBSYS_NAME}/render_views_tesselated_sphere.h")
  set(srcs "src/render_views_tesselated_sphere.cpp")

  PCL_ADD_EXECUTABLE(pcl_ppf_object_recognition COMPONENT ${SUBSYS_NAME} SOURCES src/ppf_object_recognition.cpp)
  target_link_libraries(pcl_ppf_object_recognition pcl_common pcl_io pcl_filters pcl_features pcl_registration pcl_visualization pcl_sample_consensus pcl_segmentation)

  PCL_ADD_EXECUTABLE(pcl_multiscale_feature_persistence_example COMPONENT ${SUBSYS_NAME} SOURCES src/multiscale_feature_persistence_example.cpp)
  target_link_libraries(pcl_multiscale_feature_persistence_example pcl_common pcl_io pcl_filters pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_surfel_smoothing_test COMPONENT ${SUBSYS_NAME} SOURCES src/surfel_smoothing_test.cpp)
  target_link_libraries(pcl_surfel_smoothing_test pcl_common pcl_io pcl_surface pcl_filters pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_feature_matching COMPONENT ${SUBSYS_NAME} SOURCES src/feature_matching.cpp)
  target_link_libraries(pcl_feature_matching pcl_common pcl_io pcl_registration pcl_keypoints pcl_sample_consensus pcl_visualization pcl_search pcl_features pcl_kdtree pcl_surface pcl_segmentation)

  PCL_ADD_EXECUTABLE(pcl_convolve COMPONENT ${SUBSYS_NAME} SOURCES src/convolve.cpp)
  target_link_libraries(pcl_convolve pcl_common pcl_io pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_pcd_organized_multi_plane_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_organized_multi_plane_segmentation.cpp)
  target_link_libraries(pcl_pcd_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

  if(QHULL_FOUND)
    PCL_ADD_EXECUTABLE(pcl_pcd_select_object_plane COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_select_object_plane.cpp)
    target_link_libraries(pcl_pcd_select_object_plane pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_surface)
  endif()

  PCL_ADD_EXECUTABLE(pcl_pcd_organized_edge_detection COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_organized_edge_detection.cpp)
  target_link_libraries(pcl_pcd_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_face_trainer COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection/face_trainer.cpp)
  target_link_libraries(pcl_face_trainer pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

  PCL_ADD_EXECUTABLE(pcl_fs_face_detector COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection//filesystem_face_detection.cpp BUNDLE)
  target_link_libraries(pcl_fs_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

  PCL_ADD_EXECUTABLE(pcl_stereo_ground_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/stereo_ground_segmentation.cpp)
  target_link_libraries(pcl_stereo_ground_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_stereo)

  if(Qt5_FOUND AND QVTK_FOUND)
    # Manual registration demo
    QT5_WRAP_UI(manual_registration_ui src/manual_registration/manual_registration.ui)
    QT5_WRAP_CPP(manual_registration_moc include/pcl/apps/manual_registration.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
    PCL_ADD_EXECUTABLE(pcl_manual_registration COMPONENT ${SUBSYS_NAME} SOURCES ${manual_registration_ui} ${manual_registration_moc} src/manual_registration/manual_registration.cpp BUNDLE)
    target_link_libraries(pcl_manual_registration pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface Qt5::Widgets)

    QT5_WRAP_UI(pcd_video_player_ui src/pcd_video_player/pcd_video_player.ui)
    QT5_WRAP_CPP(pcd_video_player_moc include/pcl/apps/pcd_video_player.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
    PCL_ADD_EXECUTABLE(pcl_pcd_video_player COMPONENT ${SUBSYS_NAME} SOURCES ${pcd_video_player_ui} ${pcd_video_player_moc} src/pcd_video_player/pcd_video_player.cpp BUNDLE)
    target_link_libraries(pcl_pcd_video_player pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface Qt5::Widgets)
  endif()

  if(WITH_OPENNI)
    PCL_ADD_EXECUTABLE(pcl_openni_fast_mesh COMPONENT ${SUBSYS_NAME} SOURCES src/openni_fast_mesh.cpp BUNDLE)
    target_link_libraries(pcl_openni_fast_mesh pcl_common pcl_io pcl_visualization pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_voxel_grid COMPONENT ${SUBSYS_NAME} SOURCES src/openni_voxel_grid.cpp BUNDLE)
    target_link_libraries(pcl_openni_voxel_grid pcl_common pcl_io pcl_filters pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_octree_compression COMPONENT ${SUBSYS_NAME} SOURCES src/openni_octree_compression.cpp BUNDLE)
    target_link_libraries(pcl_openni_octree_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)

    if(HAVE_PNG)
    PCL_ADD_EXECUTABLE(pcl_openni_organized_compression COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_compression.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)
    endif()

    PCL_ADD_EXECUTABLE(pcl_openni_shift_to_depth_conversion COMPONENT ${SUBSYS_NAME} SOURCES src/openni_shift_to_depth_conversion.cpp BUNDLE)
    target_link_libraries(pcl_openni_shift_to_depth_conversion pcl_common pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_mobile_server COMPONENT ${SUBSYS_NAME} SOURCES src/openni_mobile_server.cpp)
    target_link_libraries(pcl_openni_mobile_server pcl_common pcl_io pcl_filters pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_planar_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_planar_segmentation.cpp BUNDLE)
    target_link_libraries(pcl_openni_planar_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus)

    PCL_ADD_EXECUTABLE(pcl_openni_organized_multi_plane_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_multi_plane_segmentation.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

    PCL_ADD_EXECUTABLE(pcl_openni_ii_normal_estimation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_ii_normal_estimation.cpp BUNDLE)
    target_link_libraries(pcl_openni_ii_normal_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_feature_persistence COMPONENT ${SUBSYS_NAME} SOURCES src/openni_feature_persistence.cpp BUNDLE)
    target_link_libraries(pcl_openni_feature_persistence pcl_common pcl_io pcl_filters pcl_visualization pcl_features)

    PCL_ADD_EXECUTABLE(pcl_openni_mls_smoothing COMPONENT ${SUBSYS_NAME} SOURCES src/openni_mls_smoothing.cpp BUNDLE)
    target_link_libraries(pcl_openni_mls_smoothing pcl_common pcl_io pcl_surface pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_change_viewer COMPONENT ${SUBSYS_NAME} SOURCES src/openni_change_viewer.cpp BUNDLE)
    target_link_libraries(pcl_openni_change_viewer pcl_common pcl_io pcl_kdtree pcl_octree pcl_visualization pcl_filters)

    PCL_ADD_EXECUTABLE(pcl_openni_uniform_sampling COMPONENT ${SUBSYS_NAME} SOURCES src/openni_uniform_sampling.cpp BUNDLE)
    target_link_libraries(pcl_openni_uniform_sampling pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface pcl_keypoints)

    PCL_ADD_EXECUTABLE(pcl_openni_boundary_estimation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_boundary_estimation.cpp BUNDLE)
    target_link_libraries(pcl_openni_boundary_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_organized_edge_detection COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_edge_detection.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_face_detector COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection//openni_face_detection.cpp src/face_detection//openni_frame_source.cpp BUNDLE)
    target_link_libraries(pcl_openni_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree ${VTK_LIBRARIES})

    if(Qt5_FOUND AND QVTK_FOUND)
    # OpenNI Passthrough application demo
    QT5_WRAP_UI(openni_passthrough_ui src/openni_passthrough.ui)
    QT5_WRAP_CPP(openni_passthrough_moc include/pcl/apps/openni_passthrough.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
    PCL_ADD_EXECUTABLE(pcl_openni_passthrough COMPONENT ${SUBSYS_NAME} SOURCES ${openni_passthrough_ui} ${openni_passthrough_moc} src/openni_passthrough.cpp)
    target_link_libraries(pcl_openni_passthrough pcl_common pcl_io pcl_filters pcl_visualization Qt5::Widgets)

    # OpenNI Organized Connected Component application demo
    QT5_WRAP_UI(organized_segmentation_demo_ui src/organized_segmentation_demo.ui)
    QT5_WRAP_CPP(organized_segmentation_demo_moc include/pcl/apps/organized_segmentation_demo.h OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
    PCL_ADD_EXECUTABLE(pcl_organized_segmentation_demo COMPONENT ${SUBSYS_NAME} SOURCES ${organized_segmentation_demo_ui} ${organized_segmentation_demo_moc} src/organized_segmentation_demo.cpp BUNDLE)
    target_link_libraries(pcl_organized_segmentation_demo pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface Qt5::Widgets)
    endif()

    if(QHULL_FOUND)
    PCL_ADD_EXECUTABLE(pcl_openni_3d_convex_hull COMPONENT ${SUBSYS_NAME} SOURCES src/openni_3d_convex_hull.cpp BUNDLE)

=== common/CMakeLists.txt ===
set(SUBSYS_NAME common)
set(SUBSYS_DESC "Point cloud common library")
set(SUBSYS_DEPS)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS eigen boost)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(range_image_incs
  include/pcl/range_image/bearing_angle_image.h
  include/pcl/range_image/range_image.h
  include/pcl/range_image/range_image_planar.h
  include/pcl/range_image/range_image_spherical.h
)

set(range_image_incs_impl
  include/pcl/range_image/impl/range_image.hpp
  include/pcl/range_image/impl/range_image_planar.hpp
  include/pcl/range_image/impl/range_image_spherical.hpp
)

set(range_image_srcs
  src/bearing_angle_image.cpp
  src/range_image.cpp
  src/range_image_planar.cpp
)

set(srcs
  src/point_types.cpp
  src/pcl_base.cpp
  src/PCLPointCloud2.cpp
  src/io.cpp
  src/common.cpp
  src/correspondence.cpp
  src/distances.cpp
  src/parse.cpp
  src/poses_from_matches.cpp
  src/print.cpp
  src/projection_matrix.cpp
  src/time_trigger.cpp
  src/gaussian.cpp
  src/colors.cpp
  src/feature_histogram.cpp
  ${range_image_srcs}
)

set(incs
  include/pcl/correspondence.h
  include/pcl/exceptions.h
  include/pcl/pcl_base.h
  include/pcl/pcl_exports.h
  include/pcl/pcl_macros.h
  include/pcl/point_cloud.h
  include/pcl/point_traits.h
  include/pcl/point_types_conversion.h
  include/pcl/point_representation.h
  include/pcl/point_types.h
  include/pcl/for_each_type.h
  include/pcl/pcl_tests.h
  include/pcl/cloud_iterator.h
  include/pcl/TextureMesh.h
  include/pcl/sse.h
  include/pcl/PCLPointField.h
  include/pcl/PCLPointCloud2.h
  include/pcl/PCLImage.h
  include/pcl/PCLHeader.h
  include/pcl/ModelCoefficients.h
  include/pcl/PolygonMesh.h
  include/pcl/Vertices.h
  include/pcl/PointIndices.h
  include/pcl/register_point_struct.h
  include/pcl/conversions.h
  include/pcl/make_shared.h
)

set(common_incs
  include/pcl/common/boost.h
  include/pcl/common/angles.h
  include/pcl/common/bivariate_polynomial.h
  include/pcl/common/centroid.h
  include/pcl/common/concatenate.h
  include/pcl/common/common.h
  include/pcl/common/common_headers.h
  include/pcl/common/distances.h
  include/pcl/common/eigen.h
  include/pcl/common/copy_point.h
  include/pcl/common/io.h
  include/pcl/common/file_io.h
  include/pcl/common/intersections.h
  include/pcl/common/norms.h
  include/pcl/common/piecewise_linear_function.h
  include/pcl/common/polynomial_calculations.h
  include/pcl/common/poses_from_matches.h
  include/pcl/common/time.h
  include/pcl/common/time_trigger.h
  include/pcl/common/transforms.h
  include/pcl/common/transformation_from_correspondences.h
  include/pcl/common/vector_average.h
  include/pcl/common/pca.h
  include/pcl/common/point_tests.h
  include/pcl/common/synchronizer.h
  include/pcl/common/utils.h
  include/pcl/common/geometry.h
  include/pcl/common/gaussian.h
  include/pcl/common/point_operators.h
  include/pcl/common/spring.h
  include/pcl/common/intensity.h
  include/pcl/common/random.h
  include/pcl/common/generate.h
  include/pcl/common/projection_matrix.h
  include/pcl/common/colors.h
  include/pcl/common/feature_histogram.h
)

set(common_incs_impl
  include/pcl/common/impl/angles.hpp
  include/pcl/common/impl/bivariate_polynomial.hpp
  include/pcl/common/impl/centroid.hpp
  include/pcl/common/impl/common.hpp
  include/pcl/common/impl/eigen.hpp
  include/pcl/common/impl/intersections.hpp
  include/pcl/common/impl/copy_point.hpp
  include/pcl/common/impl/io.hpp
  include/pcl/common/impl/file_io.hpp
  include/pcl/common/impl/norms.hpp
  include/pcl/common/impl/piecewise_linear_function.hpp
  include/pcl/common/impl/polynomial_calculations.hpp
  include/pcl/common/impl/pca.hpp
  include/pcl/common/impl/transforms.hpp
  include/pcl/common/impl/transformation_from_correspondences.hpp
  include/pcl/common/impl/vector_average.hpp
  include/pcl/common/impl/gaussian.hpp
  include/pcl/common/impl/spring.hpp
  include/pcl/common/impl/intensity.hpp
  include/pcl/common/impl/random.hpp
  include/pcl/common/impl/generate.hpp
  include/pcl/common/impl/projection_matrix.hpp
  include/pcl/common/impl/accumulators.hpp
)

set(impl_incs
  include/pcl/impl/pcl_base.hpp
  include/pcl/impl/instantiate.hpp
  include/pcl/impl/point_types.hpp
  include/pcl/impl/cloud_iterator.hpp
)

set(tools_incs
  include/pcl/console/parse.h
  include/pcl/console/print.h
  include/pcl/console/time.h
)

set(kissfft_incs
  include/pcl/common/fft/_kiss_fft_guts.h
  include/pcl/common/fft/kiss_fft.h
  include/pcl/common/fft/kiss_fftr.h
)

set(kissfft_srcs
  src/fft/kiss_fft.c
  src/fft/kiss_fftr.c
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${kissfft_srcs} ${incs} ${common_incs} ${impl_incs} ${tools_incs} ${kissfft_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common ${common_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/fft ${kissfft_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/impl ${common_incs_impl})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" impl ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" console ${tools_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image ${range_image_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image/impl ${range_image_incs_impl})

=== features/CMakeLists.txt ===
set(SUBSYS_NAME features)
set(SUBSYS_DESC "Point cloud features library")
set(SUBSYS_DEPS common search kdtree octree filters 2d)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/eigen.h"
  "include/pcl/${SUBSYS_NAME}/board.h"
  "include/pcl/${SUBSYS_NAME}/flare.h"
  "include/pcl/${SUBSYS_NAME}/brisk_2d.h"
  "include/pcl/${SUBSYS_NAME}/cppf.h"
  "include/pcl/${SUBSYS_NAME}/cvfh.h"
  "include/pcl/${SUBSYS_NAME}/our_cvfh.h"
  "include/pcl/${SUBSYS_NAME}/crh.h"
  "include/pcl/${SUBSYS_NAME}/don.h"
  "include/pcl/${SUBSYS_NAME}/feature.h"
  "include/pcl/${SUBSYS_NAME}/fpfh.h"
  "include/pcl/${SUBSYS_NAME}/fpfh_omp.h"
  "include/pcl/${SUBSYS_NAME}/from_meshes.h"
  "include/pcl/${SUBSYS_NAME}/gasd.h"
  "include/pcl/${SUBSYS_NAME}/gfpfh.h"
  "include/pcl/${SUBSYS_NAME}/integral_image2D.h"
  "include/pcl/${SUBSYS_NAME}/integral_image_normal.h"
  "include/pcl/${SUBSYS_NAME}/intensity_gradient.h"
  "include/pcl/${SUBSYS_NAME}/intensity_spin.h"
  "include/pcl/${SUBSYS_NAME}/linear_least_squares_normal.h"
  "include/pcl/${SUBSYS_NAME}/moment_invariants.h"
  "include/pcl/${SUBSYS_NAME}/moment_of_inertia_estimation.h"
  "include/pcl/${SUBSYS_NAME}/multiscale_feature_persistence.h"
  "include/pcl/${SUBSYS_NAME}/narf.h"
  "include/pcl/${SUBSYS_NAME}/narf_descriptor.h"
  "include/pcl/${SUBSYS_NAME}/normal_3d.h"
  "include/pcl/${SUBSYS_NAME}/normal_3d_omp.h"
  "include/pcl/${SUBSYS_NAME}/normal_based_signature.h"
  "include/pcl/${SUBSYS_NAME}/organized_edge_detection.h"
  "include/pcl/${SUBSYS_NAME}/pfh.h"
  "include/pcl/${SUBSYS_NAME}/pfh_tools.h"
  "include/pcl/${SUBSYS_NAME}/pfhrgb.h"
  "include/pcl/${SUBSYS_NAME}/ppf.h"
  "include/pcl/${SUBSYS_NAME}/ppfrgb.h"
  "include/pcl/${SUBSYS_NAME}/shot.h"
  "include/pcl/${SUBSYS_NAME}/shot_lrf.h"
  "include/pcl/${SUBSYS_NAME}/shot_lrf_omp.h"
  "include/pcl/${SUBSYS_NAME}/shot_omp.h"
  "include/pcl/${SUBSYS_NAME}/spin_image.h"
  "include/pcl/${SUBSYS_NAME}/principal_curvatures.h"
  "include/pcl/${SUBSYS_NAME}/rift.h"
  "include/pcl/${SUBSYS_NAME}/rops_estimation.h"
  "include/pcl/${SUBSYS_NAME}/rsd.h"
  "include/pcl/${SUBSYS_NAME}/grsd.h"
  "include/pcl/${SUBSYS_NAME}/statistical_multiscale_interest_region_extraction.h"
  "include/pcl/${SUBSYS_NAME}/vfh.h"
  "include/pcl/${SUBSYS_NAME}/esf.h"
  "include/pcl/${SUBSYS_NAME}/3dsc.h"
  "include/pcl/${SUBSYS_NAME}/usc.h"
  "include/pcl/${SUBSYS_NAME}/boundary.h"
  "include/pcl/${SUBSYS_NAME}/range_image_border_extractor.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/board.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/flare.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/brisk_2d.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cppf.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cvfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/our_cvfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/crh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/don.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/feature.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/fpfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/fpfh_omp.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/gasd.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/gfpfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/integral_image2D.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/integral_image_normal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/intensity_gradient.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/intensity_spin.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/linear_least_squares_normal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/moment_invariants.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/moment_of_inertia_estimation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/multiscale_feature_persistence.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/narf.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/normal_3d.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/normal_3d_omp.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/normal_based_signature.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/organized_edge_detection.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/pfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/pfhrgb.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ppf.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ppfrgb.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/shot.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/shot_lrf.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/shot_lrf_omp.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/shot_omp.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/spin_image.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/principal_curvatures.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/rift.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/rops_estimation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/rsd.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/grsd.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/statistical_multiscale_interest_region_extraction.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/vfh.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/esf.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/3dsc.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/usc.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/boundary.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/range_image_border_extractor.hpp"
)

set(srcs
  src/board.cpp
  src/flare.cpp
  src/brisk_2d.cpp
  src/boundary.cpp
  src/cppf.cpp
  src/cvfh.cpp
  src/our_cvfh.cpp
  src/crh.cpp
  src/don.cpp
  src/fpfh.cpp
  src/gasd.cpp
  src/gfpfh.cpp
  src/integral_image_normal.cpp
  src/intensity_gradient.cpp
  src/intensity_spin.cpp
  src/linear_least_squares_normal.cpp
  src/moment_invariants.cpp
  src/moment_of_inertia_estimation.cpp
  src/multiscale_feature_persistence.cpp
  src/narf.cpp
  src/normal_3d.cpp
  src/normal_based_signature.cpp
  src/organized_edge_detection.cpp
  src/pfh.cpp
  src/ppf.cpp
  src/shot.cpp
  src/shot_lrf.cpp
  src/spin_image.cpp
  src/principal_curvatures.cpp
  src/rift.cpp
  src/rops_estimation.cpp
  src/rsd.cpp
  src/grsd.cpp
  src/statistical_multiscale_interest_region_extraction.cpp
  src/vfh.cpp
  src/esf.cpp
  src/3dsc.cpp
  src/usc.cpp
  src/range_image_border_extractor.cpp
)

if(MSVC)
  # Workaround to avoid hitting the MSVC 4GB linker memory limit when building pcl_features.
  # Disable whole program optimization (/GL) and link-time code generation (/LTCG).
  string(REPLACE "/GL" "" CMAKE_CXX_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
  string(REPLACE "/LTCG" "" CMAKE_SHARED_LINKER_FLAGS_RELEASE ${CMAKE_SHARED_LINKER_FLAGS_RELEASE})
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs})
target_link_libraries("${LIB_NAME}" pcl_common pcl_search pcl_kdtree pcl_octree pcl_filters)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})
# Install headers
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== gpu/CMakeLists.txt ===
set(SUBSYS_NAME gpu)
set(SUBSYS_DESC "Point cloud GPU libraries")
set(SUBSYS_DEPS)

option(BUILD_GPU "Build the GPU-related subsystems" ${DEFAULT})

if(NOT (BUILD_GPU AND CUDA_FOUND))
  return()
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  string(REPLACE "-Wold-style-cast" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  string(REPLACE "-Wno-invalid-offsetof" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-conversion -Wno-unused-parameter -Wno-unused-variable -Wno-unused-function -Wno-unused-but-set-variable")
endif()

collect_subproject_directory_names("${CMAKE_CURRENT_SOURCE_DIR}" "CMakeLists.txt" PCL_GPU_MODULES_NAMES PCL_GPU_MODULES_DIRS)
set(PCL_GPU_MODULES_NAMES_UNSORTED ${PCL_GPU_MODULES_NAMES})
topological_sort(PCL_GPU_MODULES_NAMES PCL_ _DEPENDS)
sort_relative(PCL_GPU_MODULES_NAMES_UNSORTED PCL_GPU_MODULES_NAMES PCL_GPU_MODULES_DIRS)
foreach(subdir ${PCL_GPU_MODULES_DIRS})
  add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/${subdir}")
endforeach()

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
  PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk rssdk rssdk2 pcap png vtk)
else()
  PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk pcap png vtk libusb-1.0)
endif()

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT WIN32)
  option(PCL_IO_ENABLE_MAND_LOCKING "Enables the use of mandatory locking on filesystems mounted using the mand option." ON)
  mark_as_advanced(PCL_IO_ENABLE_MAND_LOCKING)
  if(NOT PCL_IO_ENABLE_MAND_LOCKING)
    add_definitions(-DNO_MANDATORY_LOCKING)
  endif()
endif()

if(NOT build)
  return()
endif()

if(WITH_OPENNI2)
  set(IMAGE_INCLUDES
    include/pcl/io/image_metadata_wrapper.h
    include/pcl/io/image.h
    include/pcl/io/image_rgb24.h
    include/pcl/io/image_yuv422.h
    include/pcl/io/image_ir.h
    include/pcl/io/image_depth.h
  )

  set(IMAGE_SOURCES
    src/image_rgb24.cpp
    src/image_yuv422.cpp
    src/image_ir.cpp
    src/image_depth.cpp
  )

  set(OPENNI2_GRABBER_INCLUDES
    include/pcl/io/openni2_grabber.h
  )
  set(OPENNI2_INCLUDES
    include/pcl/io/openni2/openni.h
    include/pcl/io/openni2/openni2_metadata_wrapper.h
    include/pcl/io/openni2/openni2_frame_listener.h
    include/pcl/io/openni2/openni2_timer_filter.h
    include/pcl/io/openni2/openni2_video_mode.h
    include/pcl/io/openni2/openni2_convert.h
    include/pcl/io/openni2/openni2_device.h
    include/pcl/io/openni2/openni2_device_info.h
    include/pcl/io/openni2/openni2_device_manager.h
  )

  set(OPENNI2_GRABBER_SOURCES
    src/openni2_grabber.cpp
    src/openni2/openni2_timer_filter.cpp
    src/openni2/openni2_video_mode.cpp
    src/openni2/openni2_convert.cpp
    src/openni2/openni2_device.cpp
    src/openni2/openni2_device_info.cpp
    src/openni2/openni2_device_manager.cpp
  )

  source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
  source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

  # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
  if(MSVC)
    file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
  endif()
endif()

if(WITH_OPENNI)
  set(OPENNI_GRABBER_INCLUDES
    include/pcl/io/openni_grabber.h
    include/pcl/io/oni_grabber.h
  )

  set(OPENNI_INCLUDES
    include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
    include/pcl/io/openni_camera/openni.h
    include/pcl/io/openni_camera/openni_depth_image.h
    include/pcl/io/openni_camera/openni_device.h
    include/pcl/io/openni_camera/openni_device_kinect.h
    include/pcl/io/openni_camera/openni_device_primesense.h
    include/pcl/io/openni_camera/openni_device_xtion.h
    include/pcl/io/openni_camera/openni_device_oni.h
    include/pcl/io/openni_camera/openni_driver.h
    include/pcl/io/openni_camera/openni_exception.h
    include/pcl/io/openni_camera/openni_image.h
    include/pcl/io/openni_camera/openni_image_bayer_grbg.h
    include/pcl/io/openni_camera/openni_image_yuv_422.h
    include/pcl/io/openni_camera/openni_image_rgb24.h
    include/pcl/io/openni_camera/openni_ir_image.h
     ${IMAGE_INCLUDES}
  )
  set(OPENNI_GRABBER_SOURCES
    src/openni_camera/openni_device.cpp
    src/openni_camera/openni_device_primesense.cpp
    src/openni_camera/openni_image_bayer_grbg.cpp
    src/openni_camera/openni_depth_image.cpp
    src/openni_camera/openni_ir_image.cpp
    src/openni_camera/openni_device_kinect.cpp
    src/openni_camera/openni_device_xtion.cpp
    src/openni_camera/openni_device_oni.cpp
    src/openni_camera/openni_driver.cpp
    src/openni_camera/openni_exception.cpp
    src/openni_camera/openni_image_yuv_422.cpp
    src/openni_camera/openni_image_rgb24.cpp
    src/openni_grabber.cpp
    src/oni_grabber.cpp
    ${IMAGE_SOURCES}
  )
endif()

source_group("Image Headers" FILES ${IMAGE_INCLUDES})
source_group("Image Sources" FILES ${IMAGE_SOURCES})

if(WITH_ENSENSO)
  set(ENSENSO_GRABBER_INCLUDES
    include/pcl/io/ensenso_grabber.h
  )
  set(ENSENSO_GRABBER_SOURCES
    src/ensenso_grabber.cpp
  )
endif()

if(WITH_DAVIDSDK AND VTK_FOUND) # VTK is mandatory for OBJ/PLY/STL input/output
  set(DAVIDSDK_GRABBER_INCLUDES
    include/pcl/io/davidsdk_grabber.h
  )
  set(DAVIDSDK_GRABBER_SOURCES
    src/davidsdk_grabber.cpp
  )
endif()

if(WITH_DSSDK)
  set(DSSDK_GRABBER_INCLUDES
    include/pcl/io/depth_sense_grabber.h
  )
  set(DSSDK_GRABBER_SOURCES
    src/depth_sense_grabber.cpp
    src/depth_sense/depth_sense_grabber_impl.cpp
    src/depth_sense/depth_sense_device_manager.cpp
  )
endif()

if(WITH_RSSDK)
  set(RSSDK_GRABBER_INCLUDES
    include/pcl/io/real_sense_grabber.h
  )
  set(RSSDK_GRABBER_SOURCES
    src/real_sense_grabber.cpp
    src/real_sense/real_sense_device_manager.cpp
  )
endif()

# RSSDK2 is restricted to Windows until it is functional under other OSs
if(WIN32 AND WITH_RSSDK2)
  set(RSSDK2_GRABBER_INCLUDES
      include/pcl/io/real_sense_2_grabber.h
  )
  set(RSSDK2_GRABBER_SOURCES
      src/real_sense_2_grabber.cpp
  )
endif()

if(LIBUSB_1_FOUND)
  set(DINAST_GRABBER_INCLUDES
    include/pcl/io/dinast_grabber.h
  )
  set(DINAST_GRABBER_SOURCES
    src/dinast_grabber.cpp
  )
endif()

if(VTK_FOUND AND NOT ANDROID)
  set(VTK_IO_INCLUDES
    "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
    "include/pcl/${SUBSYS_NAME}/png_io.h"
  )
  set(VTK_IO_INCLUDES_IMPL
    "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
  )
  set(VTK_IO_SOURCE
    src/vtk_lib_io.cpp
    src/png_io.cpp
  )
  set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging vtkHybrid vtkGraphics vtkRendering vtkFiltering vtkVolumeRendering)
  # Indicates that we can rely on VTK to be present
  set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
endif()

set(PLY_SOURCES src/ply/ply_parser.cpp)
set(PLY_INCLUDES
  "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
  "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
)

PCL_ADD_LIBRARY(pcl_io_ply COMPONENT ${SUBSYS_NAME} SOURCES ${PLY_SOURCES} ${PLY_INCLUDES})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})
target_include_directories(pcl_io_ply PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

set(srcs
  src/debayer.cpp
  src/pcd_grabber.cpp
  src/pcd_io.cpp
  src/vtk_io.cpp
  src/ply_io.cpp
  src/ascii_io.cpp
  src/compression.cpp
  src/lzf.cpp
  src/lzf_image_io.cpp
  src/obj_io.cpp
  src/ifs_io.cpp
  src/image_grabber.cpp
  src/hdl_grabber.cpp
  src/vlp_grabber.cpp
  src/robot_eye_grabber.cpp
  src/file_io.cpp
  src/auto_io.cpp
  src/io_exception.cpp
  ${VTK_IO_SOURCE}
  ${OPENNI_GRABBER_SOURCES}
  ${OPENNI2_GRABBER_SOURCES}
  ${IMAGE_SOURCES}
  ${DINAST_GRABBER_SOURCES}
  ${ENSENSO_GRABBER_SOURCES}
  ${DAVIDSDK_GRABBER_SOURCES}
  ${DSSDK_GRABBER_SOURCES}
  ${RSSDK_GRABBER_SOURCES}
  ${RSSDK2_GRABBER_SOURCES}
)

if(PNG_FOUND)
  list(APPEND srcs
    src/libpng_wrapper.cpp
  )
endif()

if(PCAP_FOUND)
  set(PCAP_DEFINES -DHAVE_PCAP)
  include_directories(SYSTEM ${PCAP_INCLUDE_DIRS})
  add_definitions(${PCAP_DEFINES})
endif()

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/eigen.h"
  "include/pcl/${SUBSYS_NAME}/debayer.h"
  "include/pcl/${SUBSYS_NAME}/fotonic_grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_io.h"
  "include/pcl/${SUBSYS_NAME}/auto_io.h"
  "include/pcl/${SUBSYS_NAME}/low_level_io.h"
  "include/pcl/${SUBSYS_NAME}/lzf.h"
  "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
  "include/pcl/${SUBSYS_NAME}/io.h"
  "include/pcl/${SUBSYS_NAME}/grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_grabber.h"
  "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
  "include/pcl/${SUBSYS_NAME}/pcd_io.h"
  "include/pcl/${SUBSYS_NAME}/vtk_io.h"
  "include/pcl/${SUBSYS_NAME}/ply_io.h"
  "include/pcl/${SUBSYS_NAME}/tar.h"
  "include/pcl/${SUBSYS_NAME}/obj_io.h"
  "include/pcl/${SUBSYS_NAME}/ascii_io.h"
  "include/pcl/${SUBSYS_NAME}/ifs_io.h"
  "include/pcl/${SUBSYS_NAME}/image_grabber.h"
  "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
  "include/pcl/${SUBSYS_NAME}/vlp_grabber.h"
  "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
  "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
  "include/pcl/${SUBSYS_NAME}/io_exception.h"
  ${VTK_IO_INCLUDES}
  ${OPENNI_GRABBER_INCLUDES}
  ${OPENNI2_GRABBER_INCLUDES}
  ${IMAGE_INCLUDES}
  ${DINAST_GRABBER_INCLUDES}
  ${ENSENSO_GRABBER_INCLUDES}
  ${DAVIDSDK_GRABBER_INCLUDES}
  ${DSSDK_GRABBER_INCLUDES}
  ${RSSDK_GRABBER_INCLUDES}
  ${RSSDK2_GRABBER_INCLUDES}
  "include/pcl/${SUBSYS_NAME}/pxc_grabber.h"  # contains only depreciation note
)

set(compression_incs
  include/pcl/compression/octree_pointcloud_compression.h
  include/pcl/compression/color_coding.h
  include/pcl/compression/compression_profiles.h
  include/pcl/compression/entropy_range_coder.h
  include/pcl/compression/point_coding.h
)

if(PNG_FOUND)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_conversion.h
    include/pcl/compression/libpng_wrapper.h
  )
  if(WITH_OPENNI OR WITH_OPENNI2)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_compression.h
  )
  endif()
endif()

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ascii_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/auto_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
  include/pcl/compression/impl/entropy_range_coder.hpp
  include/pcl/compression/impl/octree_pointcloud_compression.hpp
  ${VTK_IO_INCLUDES_IMPL}
)

if(PNG_FOUND AND (WITH_OPENNI OR WITH_OPENNI2))
  list(APPEND impl_incs
    include/pcl/compression/impl/organized_pointcloud_compression.hpp
  )
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")

add_definitions(${VTK_DEFINES})
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})
target_include_directories(${LIB_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
link_directories(${VTK_LINK_DIRECTORIES})
target_link_libraries("${LIB_NAME}" pcl_common pcl_io_ply ${VTK_LIBRARIES})
if(PNG_FOUND)
  target_link_libraries("${LIB_NAME}" ${PNG_LIBRARIES})
endif()

if(LIBUSB_1_FOUND)
  target_link_libraries("${LIB_NAME}" ${LIBUSB_1_LIBRARIES})
endif()

if(WITH_OPENNI2)
  target_link_libraries(${LIB_NAME} ${OPENNI2_LIBRARIES})
endif()

if(WITH_OPENNI)
  target_link_libraries("${LIB_NAME}" ${OPENNI_LIBRARIES})
endif()

if(WITH_FZAPI)
  target_link_libraries("${LIB_NAME}" ${FZAPI_LIBS})
  if(WIN32)
  target_link_libraries("${LIB_NAME}" Version.lib)
  endif()
endif()

if(WITH_ENSENSO)
  target_link_libraries(${LIB_NAME} ${ENSENSO_LIBRARIES})
endif()

if(WITH_DAVIDSDK)
  target_link_libraries(${LIB_NAME} ${DAVIDSDK_LIBRARIES})
endif()

if(WITH_DSSDK)
  target_link_libraries(${LIB_NAME} ${DSSDK_LIBRARIES})
endif()

if(WITH_RSSDK)
  target_link_libraries(${LIB_NAME} ${RSSDK_LIBRARIES})
endif()

# RSSDK2 is restricted to Windows until it is functional under other OSs
if(WIN32 AND WITH_RSSDK2)
  target_link_libraries(${LIB_NAME} ${RSSDK2_LIBRARIES})
endif()

if(PCAP_FOUND)
  target_link_libraries("${LIB_NAME}" ${PCAP_LIBRARIES})
endif()

set(EXT_DEPS eigen3)

if(WITH_OPENNI)
  list(APPEND EXT_DEPS libopenni)
endif()
if(WITH_OPENNI2)
  list(APPEND EXT_DEPS libopenni2)
endif()
if(WITH_ENSENSO)
  list(APPEND EXT_DEPS ensenso)
endif()

PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" compression ${compression_incs})

=== ml/CMakeLists.txt ===
set(SUBSYS_NAME ml)
set(SUBSYS_DESC "Point cloud machine learning library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(incs
  "include/pcl/${SUBSYS_NAME}/branch_estimator.h"
  "include/pcl/${SUBSYS_NAME}/feature_handler.h"
  "include/pcl/${SUBSYS_NAME}/multi_channel_2d_comparison_feature.h"
  "include/pcl/${SUBSYS_NAME}/multi_channel_2d_comparison_feature_handler.h"
  "include/pcl/${SUBSYS_NAME}/multi_channel_2d_data_set.h"
  "include/pcl/${SUBSYS_NAME}/multiple_data_2d_example_index.h"
  "include/pcl/${SUBSYS_NAME}/point_xy_32i.h"
  "include/pcl/${SUBSYS_NAME}/point_xy_32f.h"
  "include/pcl/${SUBSYS_NAME}/regression_variance_stats_estimator.h"
  "include/pcl/${SUBSYS_NAME}/stats_estimator.h"
  "include/pcl/${SUBSYS_NAME}/densecrf.h"
  "include/pcl/${SUBSYS_NAME}/pairwise_potential.h"
  "include/pcl/${SUBSYS_NAME}/permutohedral.h"
  "include/pcl/${SUBSYS_NAME}/svm_wrapper.h"
  "include/pcl/${SUBSYS_NAME}/svm.h"
  "include/pcl/${SUBSYS_NAME}/kmeans.h"
)

set(dt_incs
  "include/pcl/${SUBSYS_NAME}/dt/decision_forest.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_forest_evaluator.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_forest_trainer.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_tree.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_tree_evaluator.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_tree_trainer.h"
  "include/pcl/${SUBSYS_NAME}/dt/decision_tree_data_provider.h"
)

set(ferns_incs
  "include/pcl/${SUBSYS_NAME}/ferns/fern.h"
  "include/pcl/${SUBSYS_NAME}/ferns/fern_evaluator.h"
  "include/pcl/${SUBSYS_NAME}/ferns/fern_trainer.h"
)

set(dt_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/dt/decision_forest_evaluator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/dt/decision_forest_trainer.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/dt/decision_tree_evaluator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/dt/decision_tree_trainer.hpp"
)

set(ferns_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ferns/fern_evaluator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ferns/fern_trainer.hpp"
)

set(svm_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/svm/svm_wrapper.hpp"
)

set(srcs
  src/point_xy_32i.cpp
  src/point_xy_32f.cpp
  src/densecrf.cpp
  src/pairwise_potential.cpp
  src/permutohedral.cpp
  src/svm_wrapper.cpp
  src/svm.cpp
  src/kmeans.cpp
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs})
SET_TARGET_PROPERTIES("${LIB_NAME}" PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries("${LIB_NAME}" pcl_common)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})
# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/dt" ${dt_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ferns" ${ferns_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/dt" ${dt_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/ferns" ${ferns_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/svm" ${svm_impl_incs})

=== outofcore/CMakeLists.txt ===
set(SUBSYS_NAME outofcore)
set(SUBSYS_DESC "Point cloud outofcore library")
set(SUBSYS_DEPS common io filters octree visualization)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/cJSON.cpp
  src/outofcore_node_data.cpp
  src/outofcore_base_data.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/metadata.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_base_data.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_node_data.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_iterator_base.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_breadth_first_iterator.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_depth_first_iterator.h"
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/cJSON.h"
  "include/pcl/${SUBSYS_NAME}/octree_base.h"
  "include/pcl/${SUBSYS_NAME}/octree_base_node.h"
  "include/pcl/${SUBSYS_NAME}/octree_abstract_node_container.h"
  "include/pcl/${SUBSYS_NAME}/octree_disk_container.h"
  "include/pcl/${SUBSYS_NAME}/octree_ram_container.h"
  "include/pcl/${SUBSYS_NAME}/outofcore.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_impl.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/outofcore_breadth_first_iterator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/outofcore_depth_first_iterator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_base.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_base_node.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_disk_container.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_ram_container.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/monitor_queue.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lru_cache.hpp"
)

set(visualization_incs
  "include/pcl/${SUBSYS_NAME}/visualization/axes.h"
  "include/pcl/${SUBSYS_NAME}/visualization/camera.h"
  "include/pcl/${SUBSYS_NAME}/visualization/common.h"
  "include/pcl/${SUBSYS_NAME}/visualization/geometry.h"
  "include/pcl/${SUBSYS_NAME}/visualization/grid.h"
  "include/pcl/${SUBSYS_NAME}/visualization/object.h"
  "include/pcl/${SUBSYS_NAME}/visualization/outofcore_cloud.h"
  "include/pcl/${SUBSYS_NAME}/visualization/scene.h"
  "include/pcl/${SUBSYS_NAME}/visualization/viewport.h"
)
set(LIB_NAME "pcl_${SUBSYS_NAME}")

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs} ${visualization_incs})
#PCL_ADD_SSE_FLAGS("${LIB_NAME}")
target_link_libraries("${LIB_NAME}" pcl_common pcl_visualization ${Boost_SYSTEM_LIBRARY})
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/visualization" ${visualization_incs})

if(BUILD_tools)
  add_subdirectory(tools)
endif()

=== recognition/CMakeLists.txt ===
set(SUBSYS_NAME recognition)
set(SUBSYS_DESC "Point cloud recognition library")
set(SUBSYS_DEPS common io search kdtree octree features filters registration sample_consensus ml)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(LINEMOD_INCLUDES
  "include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h"
)

set(LINEMOD_IMPLS
  "include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp"
)

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/color_gradient_dot_modality.h"
  "include/pcl/${SUBSYS_NAME}/color_gradient_modality.h"
  "include/pcl/${SUBSYS_NAME}/color_modality.h"
  "include/pcl/${SUBSYS_NAME}/crh_alignment.h"
  "include/pcl/${SUBSYS_NAME}/linemod.h"
  "include/pcl/${SUBSYS_NAME}/dotmod.h"
  "include/pcl/${SUBSYS_NAME}/quantizable_modality.h"
  "include/pcl/${SUBSYS_NAME}/quantized_map.h"
  "include/pcl/${SUBSYS_NAME}/dot_modality.h"
  "include/pcl/${SUBSYS_NAME}/region_xy.h"
  "include/pcl/${SUBSYS_NAME}/mask_map.h"
  "include/pcl/${SUBSYS_NAME}/point_types.h"
  "include/pcl/${SUBSYS_NAME}/distance_map.h"
  "include/pcl/${SUBSYS_NAME}/dense_quantized_multi_mod_template.h"
  "include/pcl/${SUBSYS_NAME}/sparse_quantized_multi_mod_template.h"
  "include/pcl/${SUBSYS_NAME}/surface_normal_modality.h"
  "include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h"
  "include/pcl/${SUBSYS_NAME}/implicit_shape_model.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/hypothesis.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h"
)

set(ransac_based_incs
  "include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/hypothesis.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h"
)

set(hv_incs
  "include/pcl/${SUBSYS_NAME}/hv/occlusion_reasoning.h"
  "include/pcl/${SUBSYS_NAME}/hv/hypotheses_verification.h"
  "include/pcl/${SUBSYS_NAME}/hv/hv_papazov.h"
  "include/pcl/${SUBSYS_NAME}/hv/hv_go.h"
  "include/pcl/${SUBSYS_NAME}/hv/greedy_verification.h"
)

set(face_detection_incs
  "include/pcl/${SUBSYS_NAME}/face_detection/face_common.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/face_detector_data_provider.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/rf_face_detector_trainer.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/rf_face_utils.h"
)

set(cg_incs
  "include/pcl/${SUBSYS_NAME}/cg/correspondence_grouping.h"
  "include/pcl/${SUBSYS_NAME}/cg/hough_3d.h"
  "include/pcl/${SUBSYS_NAME}/cg/geometric_consistency.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/implicit_shape_model.hpp"
)

set(ransac_based_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp"
)

set(hv_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/hv/occlusion_reasoning.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/hv_papazov.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/greedy_verification.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/hv_go.hpp"
)

set(cg_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/cg/correspondence_grouping.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cg/hough_3d.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cg/geometric_consistency.hpp"
)

set(srcs
  src/linemod.cpp
  src/quantizable_modality.cpp
  src/dotmod.cpp
  src/mask_map.cpp
  src/hv/occlusion_reasoning.cpp
  src/hv/hv_papazov.cpp
  src/hv/hv_go.cpp
  src/hv/greedy_verification.cpp
  src/cg/hough_3d.cpp
  src/cg/geometric_consistency.cpp
  src/ransac_based/obj_rec_ransac.cpp
  src/ransac_based/model_library.cpp
  src/ransac_based/orr_octree.cpp
  src/ransac_based/orr_octree_zprojection.cpp
  src/face_detection/face_detector_data_provider.cpp
  src/face_detection/rf_face_detector_trainer.cpp
  src/implicit_shape_model.cpp
)

if(HAVE_METSLIB)
  set(metslib_incs "")
else()
  set(metslib_incs
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/abstract-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/local-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/mets.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/metslib_config.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/model.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/observer.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/simulated-annealing.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/tabu-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/termination-criteria.hh"
  )
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs} ${face_detection_incs} ${ransac_based_incs} ${ransac_based_impl_incs} ${hv_incs} ${hv_impl_incs} ${cg_incs} ${cg_impl_incs} ${metslib_incs})
target_link_libraries("${LIB_NAME}" pcl_common pcl_kdtree pcl_octree pcl_search pcl_features pcl_registration pcl_sample_consensus pcl_filters pcl_ml pcl_io)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})
# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ransac_based" ${ransac_based_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/hv" ${hv_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/cg" ${cg_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/face_detection" ${face_detection_incs})

PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/ransac_based" ${ransac_based_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/hv" ${hv_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/cg" ${cg_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/linemod" ${LINEMOD_INCLUDES})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/linemod" ${LINEMOD_IMPLS})

if(NOT HAVE_METSLIB)
  PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/3rdparty/metslib" ${metslib_incs})
endif()

=== simulation/CMakeLists.txt ===
set(SUBSYS_NAME simulation)
set(SUBSYS_DESC "Point Cloud Library Simulation")
set(SUBSYS_DEPS common io surface kdtree features search octree visualization filters geometry)

set(build FALSE)
find_package(OpenGL)
find_package(GLEW)

PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" OFF)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS opengl glew)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
   src/camera.cpp
   src/model.cpp
   src/range_likelihood.cpp
   src/scene.cpp
   src/glsl_shader.cpp
   src/sum_reduce.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/camera.h"
  "include/pcl/${SUBSYS_NAME}/model.h"
  "include/pcl/${SUBSYS_NAME}/range_likelihood.h"
  "include/pcl/${SUBSYS_NAME}/scene.h"
  "include/pcl/${SUBSYS_NAME}/glsl_shader.h"
  "include/pcl/${SUBSYS_NAME}/sum_reduce.h"
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs})

target_link_libraries("${LIB_NAME}" pcl_common pcl_io
            ${OPENGL_LIBRARIES} GLEW::GLEW)

set(EXT_DEPS eigen3)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})

add_subdirectory(tools)

=== test/CMakeLists.txt ===
set(SUBSYS_NAME global_tests)
set(SUBSYS_DESC "Point cloud library global unit tests")

set(DEFAULT OFF)
set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS ${OPT_DEPS})

if(NOT build)
  return()
endif()

find_package(GTestSource REQUIRED)
include_directories(SYSTEM ${GTEST_INCLUDE_DIRS} ${GTEST_SRC_DIR})

add_library(pcl_gtest STATIC ${GTEST_SRC_DIR}/src/gtest-all.cc)

enable_testing()
add_custom_target(tests "${CMAKE_CTEST_COMMAND}" "-V" VERBATIM)
set_target_properties(tests PROPERTIES FOLDER "Tests")

add_subdirectory(2d)
add_subdirectory(common)
add_subdirectory(features)
add_subdirectory(filters)
add_subdirectory(geometry)
add_subdirectory(io)
add_subdirectory(kdtree)
add_subdirectory(keypoints)
add_subdirectory(people)
add_subdirectory(octree)
add_subdirectory(outofcore)
add_subdirectory(recognition)
add_subdirectory(registration)
add_subdirectory(search)
add_subdirectory(surface)
add_subdirectory(segmentation)
add_subdirectory(sample_consensus)
add_subdirectory(visualization)

=== debian/changelog ===
pcl (1.10.0+dfsg-5ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on arm64 and ppc64el, don't force clang

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Feb 2020 20:23:38 +0100

pcl (1.10.0+dfsg-5) unstable; urgency=medium

  * Add patch to link against atomic (for armel)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 02 Feb 2020 00:35:04 +0100

pcl (1.10.0+dfsg-4ubuntu2) focal; urgency=medium

  * reduce parallelism on arm64 and ppc64el, don't force clang

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 02 Feb 2020 01:12:00 +0100

pcl (1.10.0+dfsg-4ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on arm64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 01 Feb 2020 11:34:01 -0800

pcl (1.10.0+dfsg-4) unstable; urgency=medium

  * Use clang where gcc fails due to virtual memory exhaustion

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 31 Jan 2020 23:12:44 +0100

pcl (1.10.0+dfsg-3) unstable; urgency=medium

  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 30 Jan 2020 22:08:04 +0100

pcl (1.10.0+dfsg-2) experimental; urgency=medium

  * Reduce parallel jobs on armhf/el

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 29 Jan 2020 23:50:58 +0100

pcl (1.10.0+dfsg-1) experimental; urgency=medium

  * Update watch and copyright
  * New upstream version 1.10.0+dfsg
  * Update d/copyright
  * update patch
  * Rename packages due to soVersion bump
  * switch to debhelper-compat and debhelper 12

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 25 Jan 2020 09:53:21 +0100

pcl (1.9.1+dfsg1-10ubuntu3) focal; urgency=medium

  * No-change rebuild against libvtk7.1p

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 06 Nov 2019 05:21:53 +0000

pcl (1.9.1+dfsg1-10ubuntu2) eoan; urgency=medium

  * Merge from Debian unstable.  Remaining changes
    - reduce parallelism on arm64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Apr 2019 12:03:47 +0200

pcl (1.9.1+dfsg1-10ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on arm64 and ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Apr 2019 10:19:20 +0200

=== debian/control ===
Source: pcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
	   Jochen Sprickerhof <jspricke@debian.org>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12), dh-exec,
               cmake,
	       clang [mipsel armel armhf],
	       python3-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev, 
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk7-dev,
	       libqhull-dev,
	       libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	       libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	       libqt5opengl5-dev,
	       libusb-1.0-0-dev,
	       freeglut3-dev, 
	       libxmu-dev,
	       libxi-dev,
	       libpcap-dev,
	       libvtk7-qt-dev,
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/pcl
Vcs-Git: https://salsa.debian.org/science-team/pcl.git
Rules-Requires-Root: no
Homepage: http://www.pointclouds.org/

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk7-dev,
	 libqhull-dev,
	 libvtk7-qt-dev,
	 libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	 libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	 libpcl-apps1.10 (= ${binary:Version}),
	 libpcl-common1.10 (= ${binary:Version}),
	 libpcl-features1.10 (= ${binary:Version}),
	 libpcl-filters1.10 (= ${binary:Version}),
	 libpcl-io1.10 (= ${binary:Version}),
	 libpcl-kdtree1.10 (= ${binary:Version}),
	 libpcl-keypoints1.10 (= ${binary:Version}),
	 libpcl-ml1.10 (= ${binary:Version}),
	 libpcl-octree1.10 (= ${binary:Version}),
	 libpcl-outofcore1.10 (= ${binary:Version}),
	 libpcl-people1.10 (= ${binary:Version}),
	 libpcl-recognition1.10 (= ${binary:Version}),
	 libpcl-registration1.10 (= ${binary:Version}),
	 libpcl-sample-consensus1.10 (= ${binary:Version}),
	 libpcl-search1.10 (= ${binary:Version}),
	 libpcl-segmentation1.10 (= ${binary:Version}),
	 libpcl-stereo1.10 (= ${binary:Version}),
	 libpcl-surface1.10 (= ${binary:Version}),
	 libpcl-tracking1.10 (= ${binary:Version}),
	 libpcl-visualization1.10 (= ${binary:Version}),
	 ${misc:Depends}
Suggests: libpcl-doc
Breaks: libvtk6-dev,
        libvtk6-java,
        libvtk6-jni,
        libvtk6-qt-dev,
Description: Point Cloud Library - development files
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl-apps1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - apps library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending 
 on PCL apps.

Package: libpcl-common1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - common library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL common library.

Package: libpcl-features1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - features library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL features library.

Package: libpcl-filters1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - filters library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL filters library.

Package: libpcl-io1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - I/O library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL io.

Package: libpcl-kdtree1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - kdtree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - keypoints library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL keypoints library.

Package: libpcl-ml1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - ml library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL ml library.

Package: libpcl-octree1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - octree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL octree library.

Package: libpcl-outofcore1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - outofcore library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL outofcore.

Package: libpcl-people1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - people library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL people.

Package: libpcl-recognition1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
    	 ${misc:Depends}
Description: Point Cloud Library - recognition library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL recognition.

Package: libpcl-registration1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - registration library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - sample consensus library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - search library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - segmentation library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL segmentation library.

Package: libpcl-stereo1.10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - stereo library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) -g1
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)
ifneq (,$(filter $(DEB_BUILD_ARCH),arm64 ppc64el))
  PARALLEL=--max-parallel=2
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel armhf armel))
  PARALLEL=--max-parallel=2
  export CC=/usr/bin/clang
  export CXX=/usr/bin/clang++
else
  PARALLEL=
endif

.PHONY: override_dh_auto_configure \
	override_dh_install \
	override_dh_installchangelogs

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON -DPCL_ENABLE_SSE=OFF			\
	-DBUILD_TESTS=OFF -DBUILD_apps=ON -DBUILD_common=ON		\
	-DBUILD_examples=ON -DBUILD_features=ON -DBUILD_filters=ON	\
	-DBUILD_geometry=ON -DBUILD_global_tests=OFF -DBUILD_io=ON	\
	-DBUILD_kdtree=ON -DBUILD_keypoints=ON -DBUILD_octree=ON	\
	-DBUILD_registration=ON -DBUILD_sample_consensus=ON		\
	-DBUILD_search=ON -DBUILD_segmentation=ON -DBUILD_surface=ON	\
	-DBUILD_tools=ON -DBUILD_tracking=ON -DBUILD_visualization=ON   \
	-DBUILD_apps_cloud_composer=OFF -DBUILD_apps_modeler=ON            \
	-DBUILD_apps_point_cloud_editor=ON -DBUILD_apps_in_hand_scanner=ON \
	$(BUILD_DOC)

override_dh_install:
	@for i in pcl_concatenate_points_pcd pcl_grabcut_2d \
		pcl_elch pcl_dinast_grabber pcl_hdl_grabber \
		pcl_icp pcl_icp2d pcl_lum pcl_manual_registration pcl_match_linemod_template \
		pcl_multiscale_feature_persistence_example pcl_ndt2d pcl_ndt3d pcl_ni_agast \
		pcl_ni_linemod pcl_ni_susan pcl_nn_classification_example \
		pcl_obj_rec_ransac_hash_table pcl_openni_grabber_depth_example \
		pcl_openni_grabber_example pcl_openni_mobile_server \
		pcl_openni_organized_multi_plane_segmentation \
		pcl_openni_passthrough pcl_openni_shift_to_depth_conversion \
		pcl_openni_voxel_grid pcl_organized_segmentation_demo pcl_outofcore_print \
		pcl_outofcore_process pcl_pcd_image_viewer \
		pcl_pcd_organized_multi_plane_segmentation pcl_pcd_video_player \
		pcl_point_cloud_editor pcl_pyramid_surface_matching pcl_radius_filter \
		pcl_statistical_multiscale_interest_region_extraction_example \
		pcl_registration_visualizer pcl_surfel_smoothing_test \
		pcl_timed_trigger_test pcl_viewer pcl_virtual_scanner \
		pcl_voxel_grid_occlusion_estimation pcl_compute_hausdorff \
		pcl_generate pcl_grid_min pcl_in_hand_scanner pcl_local_max \
		pcl_morph pcl_ni_trajkovic pcl_obj2pcd pcl_offline_integration 	\
		pcl_openni_klt pcl_progressive_morphological_filter \
		pcl_converter pcl_crf_segmentation pcl_face_trainer pcl_fs_face_detector \
		pcl_ni_brisk pcl_obj2ply pcl_openni_face_detector \
		pcl_openni_organized_edge_detection pcl_outofcore_viewer \
		pcl_pcd_introduce_nan pcl_pcd_organized_edge_detection \
		pcl_stereo_ground_segmentation pcl_train_unary_classifier \
		pcl_unary_classifier_segment pcl_vlp_viewer pcl_openni2_viewer \
		pcl_openni_organized_multi_plane_segmentation; do \
	cmd="dh_link -p pcl-tools usr/share/man/man1/pcl_pointclouds.1 usr/share/man/man1/$$i.1"; \
	echo $$cmd; $$cmd; \
	done
		
	dh_install

#override_dh_shlibdeps:
#	dh_shlibdeps -v -Xusr/bin/pcl_* -Lpcl-tools -l:$(CURDIR)/debian/usr/lib/${DEB_HOST_MULTIARCH}/cloud_composer_plugins: -ppcl --- -xpcl-tools -v

override_dh_installchangelogs:
	dh_installchangelogs -plibpcl-common1.10 CHANGES.md
	# Creating dh_links to share the same file
	@for i in libpcl-dev libpcl1.10 libpcl-apps1.10 \
		libpcl-features1.10 libpcl-filters1.10 libpcl-io1.10 libpcl-kdtree1.10 \
		libpcl-keypoints1.10 libpcl-octree1.10 libpcl-outofcore1.10 libpcl-people1.10 \
		libpcl-recognition1.10 libpcl-registration1.10 libpcl-sample-consensus1.10 \
		libpcl-search1.10 libpcl-segmentation1.10 libpcl-stereo1.10 \
		libpcl-surface1.10 libpcl-tracking1.10 libpcl-visualization1.10 \
		pcl-tools libpcl-doc; do \
	cmd="dh_link -p$$i usr/share/doc/libpcl-common1.10/changelog.gz usr/share/doc/$$i/changelog.gz"; \
	echo $$cmd; $$cmd; \
	done
	dh_installchangelogs


%:
	dh  $@ $(PARALLEL) --builddirectory=build

=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg,\
    filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pcl-$1.tar.gz%" \
    https://github.com/PointCloudLibrary/pcl/releases \
    (?:.*?/)?v?pcl-(\d[\d.]*)\.tar\.gz
